C_PATH=./source/c/
H_PATH=./source/include/
ASM_PATH=./source/asm/
OBJ_PATH=./source/object/dos/

OBJ_NAMES=\
advanced.o alleg2.o area.o army.o autoplay.o back.o bigdata.o code.o config.o cursor.o decal.o dialog.o disk.o disp.o distor.o error.o exit.o fighter.o game.o gfxmode.o grad.o graphics.o help.o info.o init.o joystick.o keyboard.o level.o log.o main.o map.o menu.o mesh.o message.o mouse.o move.o options.o palette.o parser.o pion.o play.o profile.o rules.o score.o sound.o startup.o team.o texture.o ticker.o time.o viewport.o volume.o watchdog.o wave.o glouglou.o monster.o spread.o

OBJ_FILES=$(addprefix $(OBJ_PATH),$(OBJ_NAMES))

C_FLAGS=-O3 -fomit-frame-pointer -I$(H_PATH)
C_COMPILE=gcc -c $< -o $@ $(C_FLAGS)
ASM_COMPILE=gcc -c $< -o $@

all: lwdos.exe

$(OBJ_PATH)advanced.o: $(C_PATH)advanced.c
	$(C_COMPILE)

$(OBJ_PATH)alleg2.o: $(C_PATH)alleg2.c
	$(C_COMPILE)

$(OBJ_PATH)area.o: $(C_PATH)area.c
	$(C_COMPILE)

$(OBJ_PATH)army.o: $(C_PATH)army.c
	$(C_COMPILE)

$(OBJ_PATH)autoplay.o: $(C_PATH)autoplay.c
	$(C_COMPILE)

$(OBJ_PATH)back.o: $(C_PATH)back.c
	$(C_COMPILE)

$(OBJ_PATH)bigdata.o: $(C_PATH)bigdata.c
	$(C_COMPILE)

$(OBJ_PATH)code.o: $(C_PATH)code.c
	$(C_COMPILE)

$(OBJ_PATH)config.o: $(C_PATH)config.c
	$(C_COMPILE)

$(OBJ_PATH)cursor.o: $(C_PATH)cursor.c
	$(C_COMPILE)

$(OBJ_PATH)decal.o: $(C_PATH)decal.c
	$(C_COMPILE)

$(OBJ_PATH)dialog.o: $(C_PATH)dialog.c
	$(C_COMPILE)

$(OBJ_PATH)disk.o: $(C_PATH)disk.c
	$(C_COMPILE)

$(OBJ_PATH)disp.o: $(C_PATH)disp.c
	$(C_COMPILE)

$(OBJ_PATH)distor.o: $(C_PATH)distor.c
	$(C_COMPILE)

$(OBJ_PATH)error.o: $(C_PATH)error.c
	$(C_COMPILE)

$(OBJ_PATH)exit.o: $(C_PATH)exit.c
	$(C_COMPILE)

$(OBJ_PATH)fighter.o: $(C_PATH)fighter.c
	$(C_COMPILE)

$(OBJ_PATH)game.o: $(C_PATH)game.c
	$(C_COMPILE)

$(OBJ_PATH)gfxmode.o: $(C_PATH)gfxmode.c
	$(C_COMPILE)

$(OBJ_PATH)grad.o: $(C_PATH)grad.c
	$(C_COMPILE)

$(OBJ_PATH)graphics.o: $(C_PATH)graphics.c
	$(C_COMPILE)

$(OBJ_PATH)help.o: $(C_PATH)help.c
	$(C_COMPILE)

$(OBJ_PATH)info.o: $(C_PATH)info.c
	$(C_COMPILE)

$(OBJ_PATH)init.o: $(C_PATH)init.c
	$(C_COMPILE)

$(OBJ_PATH)joystick.o: $(C_PATH)joystick.c
	$(C_COMPILE)

$(OBJ_PATH)keyboard.o: $(C_PATH)keyboard.c
	$(C_COMPILE)

$(OBJ_PATH)level.o: $(C_PATH)level.c
	$(C_COMPILE)

$(OBJ_PATH)log.o: $(C_PATH)log.c
	$(C_COMPILE)

$(OBJ_PATH)main.o: $(C_PATH)main.c
	$(C_COMPILE)

$(OBJ_PATH)map.o: $(C_PATH)map.c
	$(C_COMPILE)

$(OBJ_PATH)menu.o: $(C_PATH)menu.c
	$(C_COMPILE)

$(OBJ_PATH)mesh.o: $(C_PATH)mesh.c
	$(C_COMPILE)

$(OBJ_PATH)message.o: $(C_PATH)message.c
	$(C_COMPILE)

$(OBJ_PATH)mouse.o: $(C_PATH)mouse.c
	$(C_COMPILE)

$(OBJ_PATH)move.o: $(C_PATH)move.c
	$(C_COMPILE)

$(OBJ_PATH)options.o: $(C_PATH)options.c
	$(C_COMPILE)

$(OBJ_PATH)palette.o: $(C_PATH)palette.c
	$(C_COMPILE)

$(OBJ_PATH)parser.o: $(C_PATH)parser.c
	$(C_COMPILE)

$(OBJ_PATH)pion.o: $(C_PATH)pion.c
	$(C_COMPILE)

$(OBJ_PATH)play.o: $(C_PATH)play.c
	$(C_COMPILE)

$(OBJ_PATH)profile.o: $(C_PATH)profile.c
	$(C_COMPILE)

$(OBJ_PATH)rules.o: $(C_PATH)rules.c
	$(C_COMPILE)

$(OBJ_PATH)score.o: $(C_PATH)score.c
	$(C_COMPILE)

$(OBJ_PATH)sound.o: $(C_PATH)sound.c
	$(C_COMPILE)

$(OBJ_PATH)startup.o: $(C_PATH)startup.c
	$(C_COMPILE)

$(OBJ_PATH)team.o: $(C_PATH)team.c
	$(C_COMPILE)

$(OBJ_PATH)texture.o: $(C_PATH)texture.c
	$(C_COMPILE)

$(OBJ_PATH)ticker.o: $(C_PATH)ticker.c
	$(C_COMPILE)

$(OBJ_PATH)time.o: $(C_PATH)time.c
	$(C_COMPILE)

$(OBJ_PATH)viewport.o: $(C_PATH)viewport.c
	$(C_COMPILE)

$(OBJ_PATH)volume.o: $(C_PATH)volume.c
	$(C_COMPILE)

$(OBJ_PATH)watchdog.o: $(C_PATH)watchdog.c
	$(C_COMPILE)

$(OBJ_PATH)wave.o: $(C_PATH)wave.c
	$(C_COMPILE)


$(OBJ_PATH)glouglou.o: $(ASM_PATH)glouglou.s
	$(ASM_COMPILE)

$(OBJ_PATH)monster.o: $(ASM_PATH)monster.s
	$(ASM_COMPILE)

$(OBJ_PATH)spread.o: $(ASM_PATH)spread.s
	$(ASM_COMPILE)


lwdos.exe: $(OBJ_FILES)
	gcc -o $@ $(OBJ_FILES) -lalleg